<template>
    <q-page class="q-pa-md" style="max-width: 600px; margin: 0 auto;">
        <q-card>
            <q-card-section>
                <div class="text-h5 q-mb-md">Delete Account</div>
                <div class="q-my-sm">
                    <q-banner v-if="successMessage" type="positive" class="q-my-sm">
                        {{ successMessage }}
                    </q-banner>
                    <q-banner v-if="errorMessage" type="warning" class="q-my-sm">
                        {{ errorMessage }}
                    </q-banner>
                </div>

                <q-form @submit.prevent="onDeleteAccount">
                    <q-input v-model="username" label="Username" class="q-mb-md" required />
                    <q-input v-model="password" label="Current Password" type="password" class="q-mb-md" required />

                    <q-btn label="Delete Account" type="submit" color="negative" class="full-width" />
                </q-form>
            </q-card-section>
        </q-card>
    </q-page>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useRouter } from 'vue-router';
import { useAuth } from 'src/features/auth/hooks/auth';
import { useStore } from 'vuex';

const store = useStore();

const { error, deleteAccount } = useAuth();
const username = ref('');
const password = ref('');
const router = useRouter();
const successMessage = ref('');
const errorMessage = ref('');

async function onDeleteAccount() {
    successMessage.value = '';
    errorMessage.value = '';


    await deleteAccount({
        username: username.value,
        password: password.value
    });

    if (!error.value) {
        store.commit('logout');

        router.push('/');
    }


}
</script>

<style scoped>
.full-width {
    width: 100%;
}
</style>